CQCICD/urls.py
from django.urls import path, include
from django.contrib import admin
from cicd.views import admin as ad
from rest_framework import routers
from cicd import api

router = routers.DefaultRouter()
router.register(r'groups', api.ProjectGroupsViewSet, base_name='groups')

urlpatterns = [
    path('admin/', admin.site.urls),
    path('backend/', include('backend.urls')),
    path('', ad.Dashboard.as_view()),
    path('tasks/', include('cicd.urls', namespace='tasks')),
    path('api/', include(router.urls))
]

cicd/urls.py
from django.urls import path, re_path
from cicd.views import views, admin

app_name = 'cicd'

urlpatterns = [
    path('te/', views.TasksEntrance.as_view()),
    re_path(r'list/(?P<project>\S+)/', views.TasksList.as_view(), name="tasks-list"),  # (?P<project>\w+)/
    path('dt/', views.DeployTask.as_view(), name='dt'),
    path('status/', views.TaskStatus.as_view(), name='status'),
    path('rollback_status/', views.RollbackStatus.as_view(), name='rollback_status'),
    path('dashboard/', admin.Dashboard.as_view(), name='dashboard'),
    path('manual_task/', views.ManualTask.as_view(), name='manual_task'),
    path('retry/', views.ReTry.as_view(), name='retry'),
    path('set_hosts/', views.SetDeployHosts.as_view(), name='set_hosts'),
    path('manual/', views.ManualDoc.as_view(), name='manual'),
    path('delete_task/', views.DeleteTask.as_view(), name='delete_task'),
    path('console_log/', views.ConsoleLog.as_view(), name='console_log'),

    # cicd admin
    path('admin/add_project/', admin.AddProjects.as_view(), name='add_project'),
    re_path(r'admin/update_project/(?P<project>\S+)/', admin.UpdateProject.as_view(), name='update_project'),
    path('admin/delete_project/', admin.DeleteProject.as_view(), name='delete_project'),
    path('admin/add_group/', admin.AddGroups.as_view(), name='add_group'),
    re_path(r'admin/update_group/(?P<group>.+)/', admin.UpdateGroups.as_view(), name='update_group'),
    path('admin/delete_group/', admin.DeleteGroup.as_view(), name='delete_group'),
    path('admin/add_branch/', admin.AddBranch.as_view(), name='add_branch'),
    path('admin/update_branch/', admin.UpdateBranch.as_view(), name='update_branch'),
    path('admin/delete_branch/', admin.DeleteBranch.as_view(), name='delete_branch')

]

cicd/models.py
from django.db import models
from django.urls import reverse

# Create your models here.


class GitlabUsers(models.Model):
    user_id = models.IntegerField(primary_key=True)
    user_avatar = models.URLField(null=True)
    user_email = models.EmailField(null=True)
    user_name = models.CharField(max_length=32, null=True)
    user_username = models.CharField(max_length=32, null=True)

    def __str__(self):
        return self.user_username


class Project(models.Model):
    id = models.IntegerField(null=True, blank=True)
    name = models.CharField(primary_key=True, max_length=64)
    description = models.TextField(null=True, blank=True)
    ssh_url = models.CharField(max_length=256, null=True, blank=True)
    http_url = models.URLField(null=True, blank=True)
    homepage = models.URLField(null=True, blank=True)
    default_branch = models.CharField(max_length=12, null=True, blank=True)
    group = models.ForeignKey("ProjectGroups", null=True, related_name="Project", on_delete=models.CASCADE)

    def __str__(self):
        return self.name

    def task_list(self):
        return reverse('tasks:tasks-list', args=[self.name])


class Branches(models.Model):
    project_name = models.ForeignKey('Project', on_delete=models.CASCADE, related_name='branches')
    branch_name = models.CharField(max_length=32, null=True)
    branch_domain = models.URLField(null=True, blank=True)
    auto_deploy = models.BooleanField(default=False)
    hosts = models.CharField(max_length=1024, null=True, blank=True)

    def __str__(self):
        return '{} {}'.format(self.project_name, self.branch_name)


class ProjectGroups(models.Model):
    GroupName = models.CharField(max_length=32, null=True)
    GroupWebHook = models.URLField(null=True, blank=True)

    def __str__(self):
        return self.GroupName


class Tasks(models.Model):
    """
    记录每一次task, 自动或者手动
    """
    checkout_sha = models.CharField(max_length=64, null=True)
    event_name = models.CharField(max_length=64, null=True)
    ref = models.CharField(max_length=32, null=True)
    commits_message = models.CharField(max_length=32, null=True)
    commits_url = models.URLField(null=True)
    commits_timestamp = models.CharField(max_length=64, null=True)
    commits_author_name = models.CharField(max_length=32, null=True)
    project = models.ForeignKey('Project', to_field='name', on_delete=models.CASCADE)
    user = models.ForeignKey('GitlabUsers', to_field='user_id', null=True, on_delete=models.DO_NOTHING)
    create_time = models.DateTimeField(auto_now_add=True)
    # task status
    BuildStatus = models.BooleanField(default=False)
    DeployStatus = models.BooleanField(default=False)
    BuildTaskId = models.CharField(max_length=128, null=True)
    DeployTaskId = models.CharField(max_length=128, null=True)
    TaskState = models.CharField(max_length=24, null=True)  # current task state
    TaskType = models.CharField(max_length=24, null=True)  # auto or manual
    DeployHosts = models.CharField(max_length=1024, null=True)

    def __str__(self):
        return "{}:{}".format(self.project.name, self.commits_message)

cicd/forms/admin_forms.py
# -*- coding:utf-8 -*-
# Author:Gao Xiang

from django import forms
from cicd import models

cicd/views/admin.py
# -*- coding:utf-8 -*-
# Author:Gao Xiang
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import ListView, TemplateView, UpdateView
from django.http import JsonResponse
from django.views import View
from django.shortcuts import redirect, reverse
from cicd import models


class Dashboard(LoginRequiredMixin, ListView):
    template_name = 'admin/dashboard.html'
    model = models.Project

    def get_context_data(self, **kwargs):
        group_model = models.ProjectGroups.objects.all()
        context = {
            'projects': self.object_list,
            'project_count': self.object_list.count(),
            'task_count': models.Tasks.objects.count(),
            'group_count': group_model.count(),
            'groups': group_model,
            'branches': models.Branches.objects.all(),
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)


class AddProjects(LoginRequiredMixin, ListView):
    template_name = 'admin/add_project.html'
    model = models.ProjectGroups

    def get_context_data(self, **kwargs):
        context = {
            'groups': self.object_list,
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)

    def post(self, request):
        context = {
            'name': request.POST.get('project_name'),
            'ssh_url': request.POST.get('ssh_url'),
            'group': self.model.objects.get(GroupName=request.POST.get('group_name')),
        }
        obj, created = models.Project.objects.get_or_create(
            defaults=context,
            name=request.POST.get('project_name')
        )
        if not created:
            return JsonResponse({
                'status': False,
                'err': 'the project you submit is already in database'
            })
        if request.POST.get('branch_name'):
            branch_context = {
                'project_name': obj,
                'branch_name': request.POST.get('branch_name'),
                'branch_domain': request.POST.get('branch_domain'),
                'auto_deploy': True if request.POST.get('auto_deploy') == 'on' else False,
                'hosts': request.POST.get('hosts')
            }
            obj, created = models.Branches.objects.get_or_create(
                defaults=branch_context,
                project_name=obj,
                branch_name=request.POST.get('branch_name')
            )
            if not created:
                return JsonResponse({
                    'status': False,
                    'err': 'the project and branch you submit is already in database'
                })
        return redirect(
            reverse(
                'tasks:tasks-list',
                kwargs={'project': request.POST.get('project_name')}
            )
        )


class UpdateProject(LoginRequiredMixin, TemplateView):
    template_name = 'admin/update_project.html'

    def get_context_data(self, **kwargs):
        context = {
            'project_name': self.kwargs.get('project'),
            'project': models.Project.objects.get(name=self.kwargs.get('project')),
            'branch': models.Branches.objects.filter(project_name=self.kwargs.get('project'),
                                                     branch_name=self.request.GET.get('branch_name')
                                                     ).first(),
            'groups': models.ProjectGroups.objects.all()
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)

    def post(self, request, **kwargs):
        context = {
            'name': request.POST.get('project_name'),
            'ssh_url': request.POST.get('ssh_url'),
            'group': models.ProjectGroups.objects.get(GroupName=request.POST.get('group_name')),
        }
        obj, created = models.Project.objects.update_or_create(
            name=request.POST.get('project_name'),
            defaults=context
        )
        if request.POST.get('branch_name'):
            branch_context = {
                'project_name': obj,
                'branch_name': request.POST.get('branch_name'),
                'branch_domain': request.POST.get('branch_domain'),
                'auto_deploy': True if request.POST.get('auto_deploy') == 'on' else False,
                'hosts': request.POST.get('hosts')
            }
            obj = models.Branches.objects.update_or_create(
                project_name=request.POST.get('project_name'),
                branch_name=request.POST.get('branch_name'),
                defaults=branch_context
            )
        return redirect(
            reverse('tasks:update_project',
                    kwargs={'project': request.POST.get('project_name')}
                    ) + '?branch_name={}'.format(request.POST.get('branch_name'))
        )


class DeleteProject(LoginRequiredMixin, View):
    def get(self, request):
        obj = models.Project.objects.filter(
            name=request.GET.get('project_name')
        ).delete()
        return redirect(reverse("tasks:dashboard"))


class AddGroups(LoginRequiredMixin, TemplateView):
    template_name = 'admin/add_group.html'

    def post(self, request):
        obj, created = models.ProjectGroups.objects.update_or_create(
            defaults={
                'GroupName': request.POST.get('GroupName'),
                'GroupWebHook': request.POST.get('GroupWebHook')
            },
            GroupName=request.POST.get('GroupName')
        )
        if not request.is_ajax():
            return redirect(reverse('tasks:dashboard'))
        return JsonResponse({
            'status': True,
            'group_name': obj.GroupName
        })


class UpdateGroups(LoginRequiredMixin, TemplateView):
    template_name = 'admin/update_group.html'

    def get_context_data(self, **kwargs):
        context = {
            'group': models.ProjectGroups.objects.get(GroupName=self.kwargs.get('group'))
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)

    def post(self, request, **kwargs):
        obj = models.ProjectGroups.objects.filter(
            GroupName=kwargs.get('group')
        ).update(
            GroupName=request.POST.get('GroupName'),
            GroupWebHook=request.POST.get('GroupWebHook')
        )
        return redirect(
            reverse('tasks:update_group', kwargs={'group': request.POST.get('GroupName')})
        )


class DeleteGroup(LoginRequiredMixin, View):
    def get(self, request):
        obj = models.ProjectGroups.objects.filter(
            GroupName=request.GET.get('group_name')
        ).delete()
        return redirect(reverse("tasks:dashboard"))


class AddBranch(LoginRequiredMixin, TemplateView):
    template_name = 'admin/add_branch.html'

    def get_context_data(self, **kwargs):
        context = {
            'projects': models.Project.objects.all()
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)

    def post(self, request):
        project_obj = models.Project.objects.filter(name=request.POST.get('project_name'))
        if not project_obj:
            return JsonResponse({
                'status': False,
                'err': 'invalid data'
            })
        context = {
            'project_name': project_obj.first(),
            'branch_name': request.POST.get('branch_name'),
            'branch_domain': request.POST.get('branch_domain'),
            'hosts': request.POST.get('hosts'),
            'auto_deploy': True if request.POST.get('auto_deploy') == 'on' else False,
        }
        obj, created = models.Branches.objects.get_or_create(
            defaults=context,
            branch_name=request.POST.get('branch_name'),
            project_name=request.POST.get('project_name'),
        )
        if not created:
            return JsonResponse({
                'status': False,
                'err': 'the branch and project you submit is already in used'
            })
        return redirect(reverse('tasks:dashboard'))


class UpdateBranch(LoginRequiredMixin, TemplateView):
    template_name = 'admin/update_branch.html'

    def get_context_data(self, **kwargs):
        context = {
            'branch': models.Branches.objects.get(
                project_name=self.request.GET.get('project_name'),
                branch_name=self.request.GET.get('branch_name')
            )
        }
        kwargs.update(**context)
        return super().get_context_data(**kwargs)

    def post(self, request):
        context = {
            'branch_domain': request.POST.get('branch_domain'),
            'hosts': request.POST.get('hosts'),
            'auto_deploy': True if request.POST.get('auto_deploy') == 'on' else False
        }
        obj = models.Branches.objects.filter(
            project_name=request.POST.get('project_name'),
            branch_name=request.POST.get('branch_name'),
        ).update(**context)
        return redirect(
            reverse('tasks:update_branch') + '?project_name={}&branch_name={}'.format(
                request.POST.get('project_name'),
                request.POST.get('branch_name')
            )
        )


class DeleteBranch(LoginRequiredMixin, View):
    def get(self, request):
        obj = models.Branches.objects.filter(
            branch_name=request.GET.get('branch_name'),
            project_name=request.GET.get('project_name')
        ).delete()
        return redirect(reverse("tasks:dashboard"))

cicd/templates/tasks/console.html
{% extends 'newbase.html' %}

{% block content %}
<div class="row bg-title">
    <div class="col-lg-3 col-md-4 col-sm-4 col-xs-12">
        <h4 class="page-title">Tabs</h4> </div>
    <div class="col-lg-9 col-sm-8 col-md-8 col-xs-12">
        <ol class="breadcrumb">
            <li><a href="/tasks/dashboard/">Dashboard</a></li>
            <li><a>Console log</a></li>
            <li><a>{{ project_name }}</a></li>
        </ol>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <div class="white-box">
            <h3>{{ project_name }}: {{ commits }}</h3>
            <p id="logs"></p>
            <i class="fa fa-spin fa-spinner"></i>
        </div>
    </div>
</div>
{% endblock %}

{% block js %}
<script>

function GetLogs(data){
    $.post(
    '/tasks/console_log/',
    {'offset': data['offset'], 'csrfmiddlewaretoken': '{{csrf_token}}', 'tid': '{{ tid}}'},
    function (obj) {
        ShowLog(obj)
    }
)
}

function ShowLog(obj){
    if(!obj['logs']){
        setTimeout(GetLogs, 1000, obj)
    }else {
        //let textNode = document.createElement("p");
        //textNode.innerText = obj['logs'];
        //document.getElementById('logs').appendChild(textNode);
        document.getElementById('logs').innerText += obj['logs'];
        window.scrollTo(0,document.body.scrollHeight);
        if (obj['EOF']){
            $('.fa-spin').remove();
            return
        }
        setTimeout(GetLogs, 1000, obj)
    }
}
window.onload = GetLogs({'offset': '{{ offset }}'})
</script>

{% endblock %}

cicd/templates/tasks/task_list.html
{% extends 'newbase.html' %}
{% load load_task_by_date %}
{% block css %}
    <link href="/static/newpages/plugins/bower_components/bootstrap-select/bootstrap-select.min.css" rel="stylesheet">
<style type="text/css">
 .Animation {
    animation-name: rotate;
    animation-duration: 2s;
    animation-iteration-count: infinite;
    animation-timing-function: linear;
    }
</style>
{% endblock %}
{% block content %}
    <div class="row bg-title">
        <div class="col-lg-3 col-md-4 col-sm-4 col-xs-12">
            <h4 class="page-title">Tabs</h4> </div>
        <div class="col-lg-9 col-sm-8 col-md-8 col-xs-12">
            <button class="right-side-toggle waves-effect waves-light btn-info btn-circle pull-right m-l-20" data-toggle="modal" data-target="#Modal2" data-whatever="@mdo"><i class="ti-settings text-white"></i></button>
            <div class="modal fade" id="Modal2" tabindex="-1" role="dialog" aria-labelledby="ModalLabel2" style="display: none;">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
                            <h4 class="modal-title" id="ModalLabel2">Set the destination IP address</h4> </div>
                        <div class="modal-body">
                            <form id="sethostsfrom" method="post">
                                {% csrf_token %}
                                <div class="form-group">
                                        <label for="project-name" class="control-label">Project:</label>
                                        <input type="text" class="form-control" id="project-name2" readonly name="project_name" value="{{ project_name }}">
                                    </div>
                                <div class="form-group">
                                        <label for="message-text" class="control-label">Branch:</label><br>
                                        <select class="selectpicker bs-select-hidden" data-style="form-control" name="branch_name">
                                            {% for br in branches %}
                                                <option value="{{ br.branch_name }}">{{ br.branch_name }}</option>
                                            {% endfor %}
                                        </select>
                                    </div>
                                <div class="form-group">
                                    <label class="control-label">Hosts</label>
                                    <input type="text" class="form-control" name="hosts" placeholder="多IP地址逗号分隔">
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary" data-dismiss="modal" onclick="SetHosts()">Save</button>
                        </div>
                    </div>
                </div>
            </div>
            <button class="btn btn-primary pull-right m-l-20 hidden-xs hidden-sm waves-effect waves-light" data-toggle="modal" data-target="#Modal1" data-whatever="@mdo">Manual Job</button>
            <div class="modal fade" id="Modal1" tabindex="-1" role="dialog" aria-labelledby="ModalLabel1" style="display: none;">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
                            <h4 class="modal-title" id="ModalLabel1">Manual Job Project {{ project_name }}</h4> </div>
                        <div class="modal-body">
                            <form id="manualjobform" method="post">
                                {% csrf_token %}
                                <div class="form-group">
                                    <label for="project-name" class="control-label">Project:</label>
                                    <input type="text" class="form-control" id="project-name1" readonly name="project_name" value="{{ project_name }}">
                                </div>
                                <div class="form-group">
                                    <label for="message-text" class="control-label">Branch:</label><br>
                                     <input type="text" class="form-control" name="branch_name" placeholder="请确保分支在远程仓库中存在">
{#                                    <select class="selectpicker bs-select-hidden" data-style="form-control" name="branch_name">#}
{#                                        {% for br in branches %}#}
{#                                            <option value="{{ br.branch_name }}">{{ br.branch_name }}</option>#}
{#                                        {% endfor %}#}
{#                                    </select>#}
                                </div>

                                <div class="form-group">
                                    <label class="control-label">Hosts:</label>
                                    <input type="text" class="form-control" name="hosts" placeholder="多IP地址逗号分隔">
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary" onclick="ManualJob()">Start Job</button>
                        </div>
                    </div>
                </div>
            </div>
            <ol class="breadcrumb">
                <li><a href="/tasks/dashboard/">Dashboard</a></li>
                <li><a>{{ project_group }}</a></li>
                <li class="active">{{ project_name }}</li>
            </ol>
        </div>
        <!-- /.col-lg-12 -->
    </div>

    <div class="row">
        <div class="col-md-12">
            <div class="white-box">
                <!-- Tabstyle start -->
                <section>
                    <div class="sttabs tabs-style-line">
                        <nav>
                            <ul>
                                {% for date in date_range %}
                                <li class=""><a href="#{{ date }}"><span>{{ date }}</span></a></li>
                                {% endfor %}
                            </ul>
                        </nav>
                        <!-- /content -->
                    </div>
                    <!-- /tabs -->
                </section>
            </div>
            <div class="content-wrap">
                {% for date in date_range %}
                <section id="{{ date }}" class="">
                    {% load_task date_tasks date as tasks %}
                    {% for task in tasks %}
                    <div class="panel panel-default block2">
                        <div class="panel-heading">{{ task.project }}
                            <div class="panel-action">
                                <a href="#" data-perform="panel-collapse"><i class="ti-minus"></i></a>
                                <a href="#" data-perform="panel-dismiss" onclick="DeleteTask('{{ task.id }}', '{{ task.BuildTaskId}}', '{{ task.DeployTaskId }}')"><i class="ti-close"></i></a>
                            </div>
                        </div>
                        <div class="panel-wrapper collapse in" aria-expanded="true">
                            <div class="panel-body">
                                <p style="display: inline-block">{{ task.commits_author_name }}: {{ task.commits_message }}</p>
                                {% if task.DeployStatus %}
                                    <button id="{{ task.id }}" class="btn btn-block btn-primary btn-rounded" style="width: 100px; height: 34px; float: right" onclick="Deploy(this)">Rollback</button>
                                {% else %}
                                    <button id="{{ task.id }}" class="btn btn-block btn-primary btn-rounded" style="width: 100px; height: 34px; float: right" onclick="Deploy(this)">Play</button>
                                {% endif %}
                            </div>
                            <div class="panel-footer">
                                <button class="btn btn-info btn-rounded btn-xs" style="width:50px">{% converse_time task.create_time %}</button>
                                <button class="btn btn-info btn-rounded btn-xs" style="width:65px">{{ task.TaskType }}</button>
                                <button class="btn btn-info btn-rounded btn-xs" style="width:65px">{{ task.ref }}</button>
                                {% if  task.BuildStatus %}
                                    <button id="{{ task.BuildTaskId }}" class="btn btn-info btn-rounded btn-xs" style="width:65px">build</button>
                                {% elif task.BuildTaskId and task.TaskState == 'failed' %}
                                    <button id="{{ task.BuildTaskId }}" class="btn btn-danger btn-rounded btn-xs" style="width:65px">build</button>
                                {% else %}
                                    <button id="{{ task.BuildTaskId }}" class="btn btn-warning btn-rounded btn-xs" style="width:65px">build</button>
                                {% endif %}

                                {% if task.DeployStatus %}
                                    <button id="{{ task.DeployTaskId }}" class="btn btn-info btn-rounded btn-xs" style="width:65px">deploy</button>
                                {% elif task.DeployTaskId and  task.TaskState == 'failed' %}
                                    <button id="{{ task.DeployTaskId }}" class="btn btn-danger btn-rounded btn-xs" style="width:65px">deploy</button>
                                {% else %}
                                    <button id="{{ task.DeployTaskId }}" class="btn btn-warning btn-rounded btn-xs" style="width:65px">deploy</button>
                                {% endif %}
                                <a href="{% url 'tasks:console_log' %}?tid={{ task.id }}"><button class="btn-xs btn-outline btn-rounded btn-info">Console</button></a>
                                {% if not task.BuildStatus and task.TaskState == 'failed' %}
                                    <button class="btn btn-danger btn-rounded btn-xs" style="width:65px" onclick="Retry(this)"><i class="fa fa-repeat"></i> Retry</button>
                                {% endif %}
                            </div>
                        </div>
                    </div>

                    {% endfor %}
                </section>
                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}

{% block js %}
    <script src="/static/newpages/js/cbpFWTabs.js"></script>
    <script type="text/javascript">
    (function() {
        [].slice.call(document.querySelectorAll('.sttabs')).forEach(function(el) {
            new CBPFWTabs(el);
        });
    })();
    </script>
    <script src="/static/cqcicd/tasklist.js"></script>
    <script src="/static/newpages/plugins/bower_components/bootstrap-select/bootstrap-select.min.js"></script>
{% endblock %}